#include <sys/types.h>
#include <sys/socket.h>
#include <stdio.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <net/if.h>

#include "prefs.h"

char
*get_ifinfo(char type[255])
{
 struct ifreq ifi;
 int sock, iftype = 0;
 char *bcast_addy, *interface = "eth0";

 sock = socket(AF_INET, SOCK_DGRAM, 0);
 if (sock < 0)
 {
  printf("socket error\n");
  exit(0);
 }

 interface = get_prefs("interface:");

 memset(&ifi, 0, sizeof(ifi));
 ifi.ifr_addr.sa_family = AF_INET;
 strncpy(ifi.ifr_name, interface, sizeof(ifi.ifr_name));

 if (!strcmp(type, "addy"))
 {
  iftype = SIOCGIFADDR;
 }
 if (!strcmp(type, "bcast"))
 {
  iftype = SIOCGIFBRDADDR;
 }

//  SIOCGIFADDR SIOCGIFBRDADDR

 if ( ioctl(sock, iftype, (caddr_t) &ifi) < 0)
 {
  printf("ioctl error %s\n", type);
  exit(0);
 }


 printf("Using %s: %s\n", type, inet_ntoa (((struct sockaddr_in *)
                &ifi.ifr_broadaddr)->sin_addr));

 bcast_addy = inet_ntoa (((struct sockaddr_in *) &ifi.ifr_broadaddr)->sin_addr);

 return bcast_addy;
}


char
*get_prefs(char pref_name[255])
{
 char dir[255], newdir[255], temp[255] = "", data[255] = "";
 char ch[255] = "";
 int i, go = 0, mdir = 0;
 FILE *fp;

 strcpy(dir, getenv("HOME"));
 strcat(dir, "/.spat/spatrc");
 fp = fopen(dir, "r");

 if (!fp)
 {
  printf("Config not found.\nAttempting to Create new\n"); /* If the file doesnt exist, create it. */
  strcpy(newdir, getenv("HOME"));
  strcat(newdir, "/.spat/");
  mdir = mkdir(newdir, 0700);
  if (mdir == 0)
  {
   printf("Created ~/.spat\n");
  }
  fp = fopen(dir, "w");
  if (!fp)
  {
   printf("Failure to create config. ARG!\n"); /* If this happens then somthing serious went down */
   exit(0);
  }
  fprintf(fp, "interface: eth0\n");
  fprintf(fp, "away: no\n");
  fclose(fp);
  printf("Wrote ~/.spat/spatrc\n");
  fp = fopen(dir, "r");
  if (!fp)
  {
   printf("OOOOOOUCH!\n");
  }
 }

 i = 0;
 while(feof(fp) != 1)
 {
  ch[i] = fgetc(fp);
  if (ch[i] == ' ')
  {
   i = -1;
  }
  if ((ch[i] == ':') && (ch[i] != ' '))
  {
   if (!strcmp(pref_name, ch))
   {
    bcopy(temp, ch, 255);
    go = 1;
    i = -1;
   }
   i = -1;
  }
  if ((ch[i] == '\n') && (go == 0) && (ch[i] != ' '))
  {
   i = -1;
   bcopy(temp, ch, 255);
  }
  if ((ch[i] == '\n') && (go == 1) && (ch[i] != ' '))
  {
   ch[i] = '\0';
   strcpy(data, ch);
   bcopy(temp, ch, 255);
   go = 0;
   i = -1;
  }
  i++;
 }
 fclose(fp);
 return data;
}

int
set_prefs(char pref_name[255], char value[255])
{
 char dir[255], ch[255], newdir[255], erase[255] = "", top[255] = "", bottom[255] = "";
 int i, go, mdir = 0, num = 0;
 FILE *fp;

 if (strcmp(pref_name, "away_log"))
 {
  strcpy(dir, getenv("HOME"));
  strcat(dir, "/.spat/spatrc");
  fp = fopen(dir, "r");
 }

 if (!strcmp(pref_name, "away_log"))
 {
  strcpy(dir, getenv("HOME"));
  strcat(dir, "/.spat/away_log");
  fp = fopen(dir, "a+");
  fprintf(fp, "%s\n", value);
  fclose(fp);
 }
 
 if (!fp)
 {
  printf("Config not found.\nAttempting to Create new\n");
  strcpy(newdir, getenv("HOME"));
  strcat(newdir, "/.spat/");
  mdir = mkdir(newdir, 0700);
  if (mdir == 0)
  {
   printf("Created ~/.spat\n");
  }
  fp = fopen(dir, "w");
  if (!fp)
  {
   printf("Failure to create config. ARG!\n");
   exit(0);
  }
  fprintf(fp, "interface: eth0\n");
  fprintf(fp, "away: no\n");
  fclose(fp);
  printf("Wrote ~/.spat/spatrc\n");
  fp = fopen(dir, "r");
  if (!fp)
  {
   printf("OOOOOOUCH!\n");
  }
 }

if (strcmp(pref_name, "away_log"))
{
		 
 num = 0;
 go = 0;
 for(i = 0; feof(fp) != 1; i++)
 {
  ch[i] = fgetc(fp);

  if (go == 0)
  {
   top[num] = ch[i];
  }

  if (!strcmp(ch, pref_name))
  {
   go = 1;
   strcat(top, " ");
   strcat(top, value);
   num = -1;
  }
  if (ch[i] == '\n')
  {
   if (go == 2)
   {
    strcat(bottom, ch);
   }
   if (go == 1)
   {
    go = 2;
   }
   bcopy(erase, ch, 255);
   i = -1;
  }
  num++;
 }
 fclose(fp);

 fp = fopen(dir, "w+");
 fprintf(fp, "%s\n", top);
 fprintf(fp, "%s", bottom);
 fclose(fp);
}
 return 0;
}

